<?php
namespace Magenest\Salesforce\Controller\Adminhtml\Queue;

use Magenest\Salesforce\Model\Queue;

/**
 * Class Account
 * @package Magenest\Salesforce\Controller\Adminhtml\Queue
 */
class Account extends \Magenest\Salesforce\Controller\Adminhtml\Queue\AbstractionAction
{
    /** @var string */
    protected $type = Queue::TYPE_ACCOUNT;

    /**
     * @return \Magento\Framework\App\ResponseInterface|void
     */
    public function execute()
    {
        if ($this->getRequest()->isAjax()) {
            $customerCollection = $this->customerCollection->create()->addFieldToSelect('entity_id');
            try {
                $ids = $this->getFilterDate($customerCollection)->getAllIds();
                $queueIds = $this->getQueueIdsByType($this->type);
                $this->_queueResource->deleteMultiQueues($queueIds);
                $this->publishData($ids, $this->type);
                $this->getResponse()->setBody($this->_json->serialize([
                    'error' => 0,
                    'message' => __('All Accounts are being added to queue.')
                ]));
                return;
            } catch (\Throwable $e) {
                $this->_logger->critical($e->getMessage());
                $this->getResponse()->setBody($this->_json->serialize([
                    'error' => 1,
                    'message' => __('Something went wrong while adding Accounts to queue. Error: ' . $e->getMessage())
                ]));
                return;
            }
        }
        return $this->_redirect('*/*/index');
    }
}
