define([
    'jquery',
    'underscore',
    'mageUtils',
    'uiRegistry',
    'Magento_Ui/js/grid/columns/actions',
    'Magento_Ui/js/modal/confirm',
    'Magento_Ui/js/modal/modal',
    'ko'
], function ($, _, utils, registry, Column, confirm, modal, ko) {
    'use strict';

    return Column.extend({
        defaults: {
            bodyTmpl: 'Magenest_Salesforce/grid/columns/widget-log',
        },
        modal: {},

        getPopupContent: function(action)
        {
            var row = this.rows[action._rowIndex];
            return row;
        },
        /**
         * Default action callback. Redirects to
         * the specified in action's data url.
         *
         * @param {String} actionIndex - Action's identifier.
         * @param {(Number|String)} recordId - Id of the record associated
         *      with a specified action.
         * @param {Object} action - Action's data.
         */
        defaultCallback: function (actionIndex, recordId, action) {
            var row,
                elementSelected = '.popup-modal-'+action.recordId,
                options = {
                    type: 'slide',
                    responsive: true,
                    innerScroll: true,
                    clickableOverlay: true,
                    modalClass: 'structure',
                    buttons: []
                };
            var popup = modal(options, $(elementSelected));
            $(elementSelected).modal("openModal");
        }
    });
});